function [ConsumerGain,ProducerLoss,WelfareLoss]=ComputeWelfareEffects(KeqBaseInd,KeqFeedInd,Feed,xgrid,kgrid,startind,breakevenprice,delta,disc,q);

stopind=length(xgrid);

workgrid=[startind:stopind];

roo=FindValueFunction(zeros(1,200),disc,q,0,1,1e-6);
roo(end+1)=1;

Svec=zeros(size(xgrid));
Cconvec=zeros(size(xgrid));
CconvecBase=zeros(size(xgrid));

CconTot=0;
CconTotBase=0;

for ind=startind:stopind,
    ind
    kfeedind=KeqFeedInd(ind);kbaseind=KeqBaseInd(ind);
%    Sflow=delta*8760*(breakevenprice-AnnualRevenue(kgrid(kfeedind),   PriceMat(kfeedind,1:ind));
%    temp=FindValueFunction(Sflow,disc,q,Sflow(1)/(1-disc),0,1e-6);
%    Svec(ind)=temp(end);
    CostflowFeed=zeros(1,ind);
    CostflowBase=zeros(1,ind);
    Sflow=zeros(1,ind);
    for cind=1:ind,
        CostflowFeed(cind)=delta*AnnualCost(kgrid(kfeedind),xgrid(cind));
        CostflowBase(cind)=delta*AnnualCost(kgrid(kbaseind),xgrid(cind));
        Sflow(cind)=delta*(8760*breakevenprice-AnnualRevenue(kgrid(kfeedind),xgrid(cind),0));
    end

    temp=FindValueFunction(Sflow,disc,q,Sflow(1)/(1-disc),0,1e-6);
    Svec(ind)=temp(ind);

    temp=FindValueFunction(CostflowFeed,disc,q,CostflowFeed(1)/(1-disc),0,1e-6);
    Cconvec(ind)=temp(end)+kgrid(kfeedind)*Svec(ind);
    
    temp=FindValueFunction(CostflowBase,disc,q,CostflowBase(1)/(1-disc),0,1e-6);
    CconvecBase(ind)=temp(end);
    
    CconTot=CconTot+Cconvec(ind)*roo(end-ind+startind);
    CconTotBase=CconTotBase+CconvecBase(ind)*roo(end-ind+startind);    
end

% Matrix that gives x-grid indexes for each k-grid block corresponding to
% a) investment moment under feed tariff, b) investment moment under no
% tariff
KtimesInd=zeros(2,KeqFeedInd(end));
for i=2:KeqFeedInd(end),
    KtimesInd(1,i)=min(find(KeqFeedInd>=i));
    if KeqBaseInd(end)<i,
        KtimesInd(2,i)=length(xgrid);
    else
        KtimesInd(2,i)=min(find(KeqBaseInd>=i));
    end
end

Csocvec=zeros(size(xgrid));
kblock=kgrid(2)-kgrid(1);
for kind=2:size(KtimesInd,2),
    kind
    if KtimesInd(2,kind)>KtimesInd(1,kind),
        Csocflow=zeros(1,KtimesInd(2,kind)-1);
        for cind=1:KtimesInd(2,kind)-1,
            Csocflow(cind)=delta*(8760*breakevenprice-AnnualRevenue(kgrid(kind),xgrid(cind),0));
        end
%        Csocflow=delta*8760*(breakevenprice-PriceMat(kind,1:KtimesInd(2,kind)-1));
        temp=FindValueFunction(Csocflow,disc,q,Csocflow(1)/(1-disc),0,1e-6);
        Csocvec(KtimesInd(1,kind))=Csocvec(KtimesInd(1,kind))+kblock*temp(KtimesInd(1,kind));
    end
end

CsocTot=0;
for ind=startind:stopind,
    CsocTot=CsocTot+Csocvec(ind)*roo(end-ind+startind);
end


ConsumerGain=CconTotBase-CconTot;
WelfareLoss=CsocTot;
ProducerLoss=CsocTot+ConsumerGain;