function out = ElPrice(Dee,x,month,oil_price)
%This function returns the electricity price corresponding to thermal 
% output level Dee-x.
% Input unit: MWh/week
% This version has price ceiling of 2000 Euros

price_ceil=2000;


% Estimated parameters of supply:
beta0=5.8900e+005;
beta_oil=-2.3987e+004;
beta_p=1185400;
monthdummies=1.0e+005*[
    4.9030;
    5.8923;
    5.7134;
    1.9819;
   -3.1712;
   -6.8442;
   -8.4908;
   -8.5129;
   -6.6464;
   -3.7149;
         0;
    2.1875;
    2.8884];

out = max(0,exp((1/beta_p)*(Dee-x-beta0-beta_oil*oil_price-monthdummies(month))));
out=min(out,price_ceil);
